osgGA::KeySwitchMatrixManipulator Class Reference

`#include <KeySwitchMatrixManipulator>`

Inheritance diagram for osgGA::KeySwitchMatrixManipulator:

## Public Types

typedef std::pair< std::string, osg::ref_ptr< CameraManipulator > > | NamedManipulator
typedef std::map< int, NamedManipulator > | KeyManipMap
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

virtual const char * | className () const
void | addMatrixManipulator (int key, std::string name, CameraManipulator *cm)
void | addNumberedMatrixManipulator (CameraManipulator *cm)
unsigned int | getNumMatrixManipulators () const
void | selectMatrixManipulator (unsigned int num)
KeyManipMap & | getKeyManipMap ()
const KeyManipMap & | getKeyManipMap () const
CameraManipulator * | getCurrentMatrixManipulator ()
const CameraManipulator * | getCurrentMatrixManipulator () const
CameraManipulator * | getMatrixManipulatorWithIndex (unsigned int key)
const CameraManipulator * | getMatrixManipulatorWithIndex (unsigned int key) const
CameraManipulator * | getMatrixManipulatorWithKey (unsigned int key)
const CameraManipulator * | getMatrixManipulatorWithKey (unsigned int key) const
virtual void | setCoordinateFrameCallback (CoordinateFrameCallback *cb)
virtual void | setByMatrix (const osg::Matrixd &matrix)
virtual void | setByInverseMatrix (const osg::Matrixd &matrix)
virtual osg::Matrixd | getMatrix () const
virtual osg::Matrixd | getInverseMatrix () const
virtual osgUtil::SceneView::FusionDistanceMode | getFusionDistanceMode () const
virtual float | getFusionDistanceValue () const
virtual void | setNode (osg::Node *n)
virtual const osg::Node * | getNode () const
virtual osg::Node * | getNode ()
virtual void | setHomePosition (const osg::Vec3d &eye, const osg::Vec3d &center, const osg::Vec3d &up, bool autoComputeHomePosition=false)
virtual void | setAutoComputeHomePosition (bool flag)
virtual void | computeHomePosition ()
virtual void | finishAnimation ()
virtual void | home (const GUIEventAdapter &ee, GUIActionAdapter &aa)
virtual void | init (const GUIEventAdapter &ee, GUIActionAdapter &aa)
virtual bool | handle (const GUIEventAdapter &ea, GUIActionAdapter &us)
virtual void | getUsage (osg::ApplicationUsage &usage) const
Public Member Functions inherited from osgGA::CameraManipulator
CoordinateFrameCallback * | getCoordinateFrameCallback ()
const CoordinateFrameCallback * | getCoordinateFrameCallback () const
osg::CoordinateFrame | getCoordinateFrame (const osg::Vec3d &position) const
osg::Vec3d | getSideVector (const osg::CoordinateFrame &cf) const
osg::Vec3d | getFrontVector (const osg::CoordinateFrame &cf) const
osg::Vec3d | getUpVector (const osg::CoordinateFrame &cf) const
virtual void | updateCamera (osg::Camera &camera)
void | setIntersectTraversalMask (unsigned int mask)
unsigned int | getIntersectTraversalMask () const
virtual void | getHomePosition (osg::Vec3d &eye, osg::Vec3d &center, osg::Vec3d &up) const
bool | getAutoComputeHomePosition () const
virtual void | computeHomePosition (const osg::Camera *camera=NULL, bool useBoundingBox=false)
virtual void | home (double)
virtual bool | handle (osgGA::Event *event, osg::Object *object, osg::NodeVisitor *nv)
Public Member Functions inherited from osgGA::GUIEventHandler
| GUIEventHandler ()
| GUIEventHandler (const GUIEventHandler &eh, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgGA, GUIEventHandler)
virtual bool | handle (const GUIEventAdapter &ea, GUIActionAdapter &aa, osg::Object *, osg::NodeVisitor *)
Public Member Functions inherited from osgGA::EventHandler
| EventHandler ()
| EventHandler (const EventHandler &eh, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgGA, EventHandler)
virtual NodeCallback * | asNodeCallback ()
virtual const NodeCallback * | asNodeCallback () const
virtual DrawableEventCallback * | asDrawableEventCallback ()
virtual const DrawableEventCallback * | asDrawableEventCallback () const
virtual EventHandler * | asEventHandler ()
virtual const EventHandler * | asEventHandler () const
virtual bool | run (osg::Object *object, osg::Object *data)
virtual void | operator() (osg::Node *node, osg::NodeVisitor *nv)
virtual void | event (osg::NodeVisitor *nv, osg::Drawable *drawable)
Public Member Functions inherited from osg::NodeCallback
| NodeCallback ()
| NodeCallback (const NodeCallback &nc, const CopyOp &copyop)
| META_Object (osg, NodeCallback)
Public Member Functions inherited from osg::Callback
| Callback ()
| Callback (const Callback &cb, const CopyOp &copyop)
| META_Object (osg, Callback)
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual StateAttributeCallback * | asStateAttributeCallback ()
virtual const StateAttributeCallback * | asStateAttributeCallback () const
virtual UniformCallback * | asUniformCallback ()
virtual const UniformCallback * | asUniformCallback () const
virtual DrawableUpdateCallback * | asDrawableUpdateCallback ()
virtual const DrawableUpdateCallback * | asDrawableUpdateCallback () const
virtual DrawableCullCallback * | asDrawableCullCallback ()
virtual const DrawableCullCallback * | asDrawableCullCallback () const
bool | traverse (osg::Object *object, osg::Object *data)
void | setNestedCallback (osg::Callback *cb)
osg::Callback * | getNestedCallback ()
const osg::Callback * | getNestedCallback () const
void | addNestedCallback (osg::Callback *nc)
void | removeNestedCallback (osg::Callback *nc)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const
Public Member Functions inherited from osg::DrawableEventCallback
| DrawableEventCallback ()
| DrawableEventCallback (const DrawableEventCallback &org, const CopyOp &copyop)
| META_Object (osg, DrawableEventCallback)

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Member Functions inherited from osgGA::CameraManipulator
| CameraManipulator ()
| CameraManipulator (const CameraManipulator &mm, const osg::CopyOp &copyOp=osg::CopyOp::SHALLOW_COPY)
virtual | ~CameraManipulator ()
std::string | getManipulatorName () const
Protected Member Functions inherited from osgGA::GUIEventHandler
virtual | ~GUIEventHandler ()
Protected Member Functions inherited from osg::NodeCallback
virtual | ~NodeCallback ()
Protected Member Functions inherited from osg::Callback
virtual | ~Callback ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const
Protected Attributes inherited from osgGA::CameraManipulator
unsigned int | _intersectTraversalMask
bool | _autoComputeHomePosition
osg::Vec3d | _homeEye
osg::Vec3d | _homeCenter
osg::Vec3d | _homeUp
osg::ref_ptr< CoordinateFrameCallback > | _coordinateFrameCallback
Protected Attributes inherited from osg::Callback
ref_ptr< Callback > | _nestedCallback
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Detailed Description

KeySwitchMatrixManipulator is a decorator which allows the type of camera manipulator being used to be switched by pressing a key. E.g. '1' for a TrackballManipulator, '2' for a DriveManipulator, '3' for a FlightManipulator. The manipulators available, and the associated switch keys, can be configured.

## Member Typedef Documentation

## KeyManipMap

typedef std::map<int, NamedManipulator> osgGA::KeySwitchMatrixManipulator::KeyManipMap

## NamedManipulator

typedef std::pair<std::string, osg::ref_ptr<CameraManipulator> > osgGA::KeySwitchMatrixManipulator::NamedManipulator

## Member Function Documentation

## addMatrixManipulator()

void osgGA::KeySwitchMatrixManipulator::addMatrixManipulator | ( | int | key,
|  | std::string | name,
|  | CameraManipulator * | cm )

Add a camera manipulator with an associated name, and a key to trigger the switch,

References osgGA::CameraManipulator::CameraManipulator().

## addNumberedMatrixManipulator()

void osgGA::KeySwitchMatrixManipulator::addNumberedMatrixManipulator | ( | CameraManipulator * | cm | ) |

Add a camera manipulator with an autogenerated keybinding which is '1' + previous number of camera's registered.

References osgGA::CameraManipulator::CameraManipulator().

## className()

virtual const char * osgGA::KeySwitchMatrixManipulator::className | ( |  | ) | const

inline virtual

return the name of the object's class type. Must be defined by derived classes.

Reimplemented from osgGA::CameraManipulator.

## computeHomePosition()

virtual void osgGA::KeySwitchMatrixManipulator::computeHomePosition | ( |  | ) |

virtual

## finishAnimation()

virtual void osgGA::KeySwitchMatrixManipulator::finishAnimation | ( |  | ) |

virtual

finish any active manipulator animations.

Reimplemented from osgGA::CameraManipulator.

## getCurrentMatrixManipulator() [1/2]

CameraManipulator * osgGA::KeySwitchMatrixManipulator::getCurrentMatrixManipulator | ( |  | ) |

inline

Get the current active manipulators.

References osgGA::CameraManipulator::CameraManipulator().

## getCurrentMatrixManipulator() [2/2]

const CameraManipulator * osgGA::KeySwitchMatrixManipulator::getCurrentMatrixManipulator | ( |  | ) | const

inline

Get the const current active manipulators.

References osgGA::CameraManipulator::CameraManipulator().

## getFusionDistanceMode()

virtual osgUtil::SceneView::FusionDistanceMode osgGA::KeySwitchMatrixManipulator::getFusionDistanceMode | ( |  | ) | const

inline virtual

Get the FusionDistanceMode. Used by SceneView for setting up stereo convergence.

Reimplemented from osgGA::CameraManipulator.

## getFusionDistanceValue()

virtual float osgGA::KeySwitchMatrixManipulator::getFusionDistanceValue | ( |  | ) | const

inline virtual

Get the FusionDistanceValue. Used by SceneView for setting up stereo convergence.

Reimplemented from osgGA::CameraManipulator.

## getInverseMatrix()

virtual osg::Matrixd osgGA::KeySwitchMatrixManipulator::getInverseMatrix | ( |  | ) | const

inline virtual

get the position of the manipulator as a inverse matrix of the manipulator, typically used as a model view matrix.

Implements osgGA::CameraManipulator.

## getKeyManipMap() [1/2]

KeyManipMap & osgGA::KeySwitchMatrixManipulator::getKeyManipMap | ( |  | ) |

inline

Get the complete list of manipulators attached to this keyswitch manipulator.

## getKeyManipMap() [2/2]

const KeyManipMap & osgGA::KeySwitchMatrixManipulator::getKeyManipMap | ( |  | ) | const

inline

Get the const complete list of manipulators attached to this keyswitch manipulator.

## getMatrix()

virtual osg::Matrixd osgGA::KeySwitchMatrixManipulator::getMatrix | ( |  | ) | const

inline virtual

get the position of the manipulator as 4x4 Matrix.

Implements osgGA::CameraManipulator.

## getMatrixManipulatorWithIndex() [1/2]

CameraManipulator * osgGA::KeySwitchMatrixManipulator::getMatrixManipulatorWithIndex | ( | unsigned int | key | ) |

Get manipulator assigned to a specified index.

References osgGA::CameraManipulator::CameraManipulator().

## getMatrixManipulatorWithIndex() [2/2]

const CameraManipulator * osgGA::KeySwitchMatrixManipulator::getMatrixManipulatorWithIndex | ( | unsigned int | key | ) | const

Get const manipulator assigned to a specified index.

References osgGA::CameraManipulator::CameraManipulator().

## getMatrixManipulatorWithKey() [1/2]

CameraManipulator * osgGA::KeySwitchMatrixManipulator::getMatrixManipulatorWithKey | ( | unsigned int | key | ) |

Get manipulator assigned to a specified key.

References osgGA::CameraManipulator::CameraManipulator().

## getMatrixManipulatorWithKey() [2/2]

const CameraManipulator * osgGA::KeySwitchMatrixManipulator::getMatrixManipulatorWithKey | ( | unsigned int | key | ) | const

Get const manipulator assigned to a specified key.

References osgGA::CameraManipulator::CameraManipulator().

## getNode() [1/2]

virtual osg::Node * osgGA::KeySwitchMatrixManipulator::getNode | ( |  | ) |

inline virtual

Return node if attached.

Reimplemented from osgGA::CameraManipulator.

## getNode() [2/2]

virtual const osg::Node * osgGA::KeySwitchMatrixManipulator::getNode | ( |  | ) | const

inline virtual

Return const node if attached.

Reimplemented from osgGA::CameraManipulator.

## getNumMatrixManipulators()

unsigned int osgGA::KeySwitchMatrixManipulator::getNumMatrixManipulators | ( |  | ) | const

inline

## getUsage()

virtual void osgGA::KeySwitchMatrixManipulator::getUsage | ( | osg::ApplicationUsage & | usage | ) | const

virtual

Get the keyboard and mouse usage of this manipulator.

Reimplemented from osgGA::EventHandler.

## handle()

virtual bool osgGA::KeySwitchMatrixManipulator::handle | ( | const GUIEventAdapter & | ea,
|  | GUIActionAdapter & | us )

virtual

Handle events, return true if handled, false otherwise.

Reimplemented from osgGA::CameraManipulator.

## home()

virtual void osgGA::KeySwitchMatrixManipulator::home | ( | const GUIEventAdapter & | ,
|  | GUIActionAdapter & | )

virtual

Move the camera to the default position. May be ignored by manipulators if home functionality is not appropriate.

Reimplemented from osgGA::CameraManipulator.

## init()

virtual void osgGA::KeySwitchMatrixManipulator::init | ( | const GUIEventAdapter & | ,
|  | GUIActionAdapter & | )

inline virtual

Start/restart the manipulator.

Reimplemented from osgGA::CameraManipulator.

## selectMatrixManipulator()

void osgGA::KeySwitchMatrixManipulator::selectMatrixManipulator | ( | unsigned int | num | ) |

## setAutoComputeHomePosition()

virtual void osgGA::KeySwitchMatrixManipulator::setAutoComputeHomePosition | ( | bool | flag | ) |

virtual

Set whether the automatic compute of the home position is enabled.

Reimplemented from osgGA::CameraManipulator.

## setByInverseMatrix()

virtual void osgGA::KeySwitchMatrixManipulator::setByInverseMatrix | ( | const osg::Matrixd & | matrix | ) |

inline virtual

set the position of the matrix manipulator using a 4x4 Matrix.

Implements osgGA::CameraManipulator.

## setByMatrix()

virtual void osgGA::KeySwitchMatrixManipulator::setByMatrix | ( | const osg::Matrixd & | matrix | ) |

inline virtual

Set the position of the matrix manipulator using a 4x4 Matrix.

Implements osgGA::CameraManipulator.

## setCoordinateFrameCallback()

virtual void osgGA::KeySwitchMatrixManipulator::setCoordinateFrameCallback | ( | CoordinateFrameCallback * | cb | ) |

virtual

set the coordinate frame which callback tells the manipulator which way is up, east and north.

Reimplemented from osgGA::CameraManipulator.

## setHomePosition()

virtual void osgGA::KeySwitchMatrixManipulator::setHomePosition | ( | const osg::Vec3d & | eye,
|  | const osg::Vec3d & | center,
|  | const osg::Vec3d & | up,
|  | bool | autoComputeHomePosition = false )

virtual

Manually set the home position, and set the automatic compute of home position.

Reimplemented from osgGA::CameraManipulator.

## setNode()

virtual void osgGA::KeySwitchMatrixManipulator::setNode | ( | osg::Node * |  | ) |

virtual

Attach a node to the manipulator, automatically detaching any previously attached node. setNode(NULL) detaches previous nodes. May be ignored by manipulators which do not require a reference model.

Reimplemented from osgGA::CameraManipulator.

The documentation for this class was generated from the following file:

- KeySwitchMatrixManipulator